package org.ets.ibt.delivery.server.utility;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;
import java.nio.file.FileVisitResult;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.attribute.BasicFileAttributes;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.zip.Inflater;

public class PackageDataUtility {

   private String dbURL = "jdbc:oracle:thin:@oco14-crs-scan.etslan.org:1526/ibtd";
   private String dbUser = "IBTPKGSB";
   private String dbPassword = "j1214$cp";
   private String dbSchema = "IBTPKGSB.";
   private static Set noChildCompTypeSet = new HashSet();


   public static void main(String[] args) {
      (new PackageDataUtility()).buildDataStructure("TELXMLISD00045000PKG001", "c:/temp");
   }

   private void buildDataStructure(String pkgId, String sourceLocation) {
      Connection conn = null;

      try {
         File e = new File(sourceLocation, pkgId);
         if(e.exists()) {
            Path compIdList = Paths.get(pkgId, new String[0]);
            Files.walkFileTree(compIdList, new SimpleFileVisitor() {
               public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) throws IOException {
                  Files.delete(file);
                  return FileVisitResult.CONTINUE;
               }
               public FileVisitResult postVisitDirectory(Path dir, IOException exc) throws IOException {
                  Files.delete(dir);
                  return FileVisitResult.CONTINUE;
               }
            });
         }

         PrintStream var10000 = System.out;
         pkgId.println(e.mkdir());
         Class.forName("oracle.jdbc.driver.OracleDriver");
         conn = DriverManager.getConnection(this.dbURL, this.dbUser, this.dbPassword);
         List var28 = this.getAllComponent(conn, pkgId);
         System.out.println(var28.size());

         for(int i = 0; i < var28.size(); ++i) {
            String compId = (String)var28.get(i);
            PrintStream var10001 = System.out;
            (i + 1).println(var28.size());
            List compList = this.readCompDataXref(conn, pkgId, compId);
            if(compList == null) {
               System.out.println(compId);
               break;
            }

            String accName = compId.substring(6, 14);
            File compDir = new File(e, accName);
            compDir.mkdir();
            Iterator var11 = compList.iterator();

            while(var11.hasNext()) {
               PackageDataUtility.ComponentData compData = (PackageDataUtility.ComponentData)var11.next();
               String type = compData.getCompId().substring(17, 20);
               File var10004;
               if(!type.equalsIgnoreCase("CTL") && !type.equalsIgnoreCase("FMT")) {
                  File var29 = new File(compDir, "resource");
                  if(!var29.exists()) {
                     var29.mkdir();
                  }

                  byte[] var30 = compData.getData();
                  var10004 = new File;
                  var29.<init>(compData.getCompId(), type);
                  File var31 = var10004;
                  FileOutputStream out = new FileOutputStream(var31);
                  out.write(var30);
                  out.close();
               } else {
                  byte[] resourceDir = compData.getData();
                  var10004 = new File;
                  compDir.<init>(compData.getCompId(), type);
                  File data = var10004;
                  FileOutputStream file = new FileOutputStream(data);
                  file.write(resourceDir);
                  file.close();
               }
            }

            System.out.println(compId);
         }

         System.out.println(var28.size());
      } catch (Exception var26) {
         var26.printStackTrace();
      } finally {
         if(conn != null) {
            try {
               conn.close();
            } catch (Exception var25) {
               var25.printStackTrace();
            }
         }

      }

   }

   private List getAllComponent(Connection conn, String pkgId) {
      Statement stmt = null;
      ResultSet resultSet = null;
      ArrayList resultList = new ArrayList();

      try {
         String var10000 = this.dbSchema;
         stmt = conn.createStatement();
         resultSet = stmt.executeQuery(pkgId);

         while(resultSet.next()) {
            resultList.add(resultSet.getString("TST_CMPNT_CDE"));
         }
      } catch (Exception var15) {
         var15.printStackTrace();
      } finally {
         try {
            if(resultSet != null) {
               resultSet.close();
            }

            if(stmt != null) {
               stmt.close();
            }
         } catch (Exception var14) {
            var14.printStackTrace();
         }

      }

      return resultList;
   }

   private List readCompDataXref(Connection conn, String pkgId, String compId) {
      ArrayList dataList = new ArrayList();
      PackageDataUtility.ComponentData componentData = this.readComponentTable(conn, pkgId, compId);
      if(componentData != null) {
         dataList.add(componentData);
      }

      HashMap compMap = new HashMap();
      this.fillWithChildrenComponents(conn, pkgId, compId, compMap);
      Statement stmt = null;
      ResultSet resultSet = null;

      String e1;
      try {
         ArrayList e;
         if(compMap.size() > 0) {
            e = new ArrayList(compMap.keySet());
            stmt = conn.createStatement();
            e1 = (String)e.get(0);

            for(int e2 = 1; e2 < e.size(); ++e2) {
               e1 = (String)e.get(e2);
            }

            String var10001 = this.dbSchema;

            String ctlCompId;
            String parentId;
            byte[] data;
            for(resultSet = stmt.executeQuery(e1); resultSet.next(); dataList.add(new PackageDataUtility.ComponentData(parentId, ctlCompId, data))) {
               ctlCompId = resultSet.getString("TST_CMPNT_CDE").trim();
               int compressedSize = resultSet.getInt("TST_CMPNT_CMPRS_SZ_NO");
               int unCompressedSize = resultSet.getInt("TST_CMPNT_UCMPRS_SZ_NO");
               parentId = (String)compMap.get(ctlCompId);
               if(compressedSize != 0) {
                  data = this.readBytes(4, resultSet, compressedSize);
                  data = this.uncompressData(data, unCompressedSize);
               } else {
                  data = this.readBytes(4, resultSet, unCompressedSize);
               }
            }

            resultSet.close();
            stmt.close();
         }

         e = dataList;
         return e;
      } catch (Exception var25) {
         var25.printStackTrace();
         e1 = null;
      } finally {
         try {
            if(resultSet != null) {
               resultSet.close();
            }

            if(stmt != null) {
               stmt.close();
            }
         } catch (Exception var24) {
            var24.printStackTrace();
         }

      }

      return e1;
   }

   private PackageDataUtility.ComponentData readComponentTable(Connection conn, String pkgId, String compId) {
      Statement stmt = null;
      ResultSet resultSet = null;

      Object compressedSize;
      try {
         stmt = conn.createStatement();
         String var10000 = this.dbSchema;
         resultSet = stmt.executeQuery(compId);
         if(resultSet.next()) {
            int compressedSize1 = resultSet.getInt("TST_CMPNT_CMPRS_SZ_NO");
            int e = resultSet.getInt("TST_CMPNT_UCMPRS_SZ_NO");
            byte[] data;
            if(compressedSize1 != 0) {
               data = this.readBytes(4, resultSet, compressedSize1);
               data = this.uncompressData(data, e);
            } else {
               data = this.readBytes(4, resultSet, e);
            }

            PackageDataUtility.ComponentData var10 = new PackageDataUtility.ComponentData((String)null, compId, data);
            return var10;
         }

         compressedSize = null;
         return (PackageDataUtility.ComponentData)compressedSize;
      } catch (Exception var21) {
         var21.printStackTrace();
         compressedSize = null;
      } finally {
         try {
            if(resultSet != null) {
               resultSet.close();
            }

            if(stmt != null) {
               stmt.close();
            }
         } catch (Exception var20) {
            var20.printStackTrace();
         }

      }

      return (PackageDataUtility.ComponentData)compressedSize;
   }

   private void fillWithChildrenComponents(Connection conn, String pkgId, String compId, Map compMap) {
      if(!noChildCompTypeSet.contains(compId.substring(17, 20))) {
         Statement stmt = null;
         ResultSet resultSet = null;

         try {
            stmt = conn.createStatement();
            String var10000 = this.dbSchema;
            resultSet = stmt.executeQuery(compId);
            ArrayList childList = new ArrayList();

            while(resultSet.next()) {
               String componentId = resultSet.getString("TST_CMPNT_CDE");
               compMap.put(componentId, compId);
               childList.add(componentId);
            }

            Iterator componentId1 = childList.iterator();

            while(componentId1.hasNext()) {
               String childId = (String)componentId1.next();
               this.fillWithChildrenComponents(conn, pkgId, childId, compMap);
            }
         } catch (SQLException var19) {
            var19.printStackTrace();
         } finally {
            try {
               if(resultSet != null) {
                  resultSet.close();
               }

               if(stmt != null) {
                  stmt.close();
               }
            } catch (Exception var18) {
               var18.printStackTrace();
            }

         }

      }
   }

   private byte[] readBytes(int pos, ResultSet rs, int len) throws Exception {
      byte[] byteArray = new byte[len];
      InputStream byteStream = rs.getBinaryStream(pos);
      byteStream.read(byteArray);
      byteStream.close();
      return byteArray;
   }

   private byte[] uncompressData(byte[] data, int uncompSize) {
      try {
         byte[] e = new byte[uncompSize + 20];
         Inflater inf = new Inflater();
         inf.setInput(data);
         int actual = inf.inflate(e);
         inf.end();
         if(actual != uncompSize) {
            return null;
         } else {
            byte[] unCompressedData = null;
            if(actual > 0) {
               unCompressedData = new byte[actual];
               System.arraycopy(e, 0, unCompressedData, 0, actual);
            }

            return unCompressedData;
         }
      } catch (Exception var7) {
         var7.printStackTrace();
         return null;
      }
   }

   static {
      noChildCompTypeSet.add("AXX");
      noChildCompTypeSet.add("VXX");
      noChildCompTypeSet.add("GXX");
      noChildCompTypeSet.add("IXX");
      noChildCompTypeSet.add("FMT");
      noChildCompTypeSet.add("GIF");
      noChildCompTypeSet.add("JPG");
      noChildCompTypeSet.add("OGG");
      noChildCompTypeSet.add("PNG");
   }

   private class ComponentData {

      private String parentId;
      private String compId;
      private byte[] data;


      public ComponentData(String parentId, String compId, byte[] data) {
         this.parentId = parentId;
         this.compId = compId;
         this.data = data;
      }

      public String getParentId() {
         return this.parentId;
      }

      public String getCompId() {
         return this.compId;
      }

      public byte[] getData() {
         return this.data;
      }
   }
}
